#   File:       ellkask.make
#   Target:     ellkask
#   Sources:    ellkask.c commands.c
#				events.c macutil.c readtr.c hyptherm.c
#				geointer.c refine.c
#				tricmd.c lists.c
#				problem.c solve.c cholesky.c cg.c ilu.c
#				shape.c numinteg.c assmul.c assfull.c
#				asscmd.c constinteg.c
#				parcmd.c params.c bpx.c tomproblem.c stdproblem.c
#				graphcmd.c graphic.c postscr.c window.c macwindow.c
#   Created:    Dienstag, 24. Januar 1989 16:48:48 Uhr

ellkask.c.o  ellkask.c kask.h kaskevnt.h kaskcmd.h
	C ellkask.c -mc68881 -mc68020 -sym on
commands.c.o  commands.c kask.h kaskcmd.h
	C commands.c -mc68881 -mc68020 -sym on -s kask
events.c.o  events.c kask.h kaskevnt.h
	C events.c -mc68881 -mc68020 -sym on -s kask
macutil.c.o  macutil.c kask.h
	C macutil.c -mc68881 -mc68020 -sym on -s kask
readtr.c.o  readtr.c kask.h kaskcmd.h kasktri.h
	C readtr.c -mc68881 -mc68020 -sym on -s triang -w
geointer.c.o  geointer.c kask.h kasktri.h
	C geointer.c -mc68881 -mc68020 -sym on -s triang
refine.c.o  refine.c kask.h kasktri.h
	C refine.c -mc68881 -mc68020 -sym on -s triang
tricmd.c.o  tricmd.c kask.h kasktri.h kaskcmd.h
	C tricmd.c -mc68881 -mc68020 -sym on -s triang
lists.c.o  lists.c kask.h kasktri.h
	C lists.c -mc68881 -mc68020 -sym on -s triang
problem.c.o  problem.c kask.h kaskass.h
	C problem.c -mc68881 -mc68020 -sym on -s solve -w
solve.c.o  solve.c kask.h kasksol.h kasktri.h kaskass.h
	C solve.c -mc68881 -mc68020 -sym on -s solve
cg.c.o  cg.c kask.h kasksol.h kasktri.h kaskass.h
	C cg.c -mc68881 -mc68020 -sym on -s solve
cholesky.c.o  cholesky.c kask.h kasksol.h
	C cholesky.c -mc68881 -mc68020 -sym on -s solve -w
ilu.c.o  ilu.c kask.h kasktri.h kasksol.h
	C ilu.c -mc68881 -mc68020 -sym on -s solve -w
shape.c.o  shape.c kask.h kaskass.h
	C shape.c -mc68881 -mc68020 -sym on -s assemb
numinteg.c.o  numinteg.c kask.h kaskass.h
	C numinteg.c -mc68881 -mc68020 -sym on -s assemb
constinteg.c.o  constinteg.c kask.h kaskass.h kaskcmd.h
	C constinteg.c -mc68881 -mc68020 -sym on -s assemb
assmul.c.o  assmul.c kask.h kaskass.h
	C assmul.c -mc68881 -mc68020 -sym on -s assemb
assfull.c.o  assfull.c kask.h kaskass.h
	C assfull.c -mc68881 -mc68020 -sym on -s assemb
asscmd.c.o  asscmd.c kask.h kaskass.h
	C asscmd.c -mc68881 -mc68020 -sym on -s assemb
graphcmd.c.o  graphcmd.c kask.h kasktri.h kaskgraph.h
	C graphcmd.c -mc68881 -mc68020 -sym on -s graph
graphic.c.o  graphic.c kask.h kasktri.h kaskgraph.h
	C graphic.c -mc68881 -mc68020 -sym on -s grapha -w
postscr.c.o  postscr.c kask.h kasktri.h kaskgraph.h
	C postscr.c -mc68881 -mc68020 -sym on -s graph
window.c.o  window.c kask.h kasktri.h kaskgraph.h
	C window.c -mc68881 -mc68020 -sym on -s graph
macwindow.c.o  macwindow.c kask.h kasktri.h kaskgraph.h
	C macwindow.c -mc68881 -mc68020 -sym on -s graph
parcmd.c.o  parcmd.c kask.h
	C parcmd.c -mc68881 -mc68020 -sym on -s kask
params.c.o  params.c kask.h kaskcmd.h
	C params.c -mc68881 -mc68020 -sym on -s graph
bpx.c.o  bpx.c kask.h kasktri.h kaskgraph.h kaskass.h kasksol.h
	C bpx.c -mc68881 -mc68020 -sym on -s solve
tomproblem.c.o  tomproblem.c kask.h kasktri.h kaskass.h
	C tomproblem.c -mc68881 -mc68020 -sym on -s assemb
stdproblem.c.o  stdproblem.c kask.h kasktri.h kaskass.h
	C stdproblem.c -mc68881 -mc68020 -sym on -s assemb

SOURCES = ellkask.c commands.c
		  events.c macutil.c readtr.c 
		  geointer.c refine.c
		  tricmd.c lists.c 
		  problem.c solve.c cholesky.c cg.c 
		  shape.c numinteg.c assmul.c assfull.c asscmd.c 
		  graphcmd.c graphic.c postscr.c window.c macwindow.c 
		  parcmd.c params.c bpx.c tomproblem.c stdproblem.c
OBJECTS = ellkask.c.o commands.c.o 
		  events.c.o macutil.c.o readtr.c.o 
		  geointer.c.o refine.c.o 
		  tricmd.c.o lists.c.o 
		  problem.c.o solve.c.o cholesky.c.o cg.c.o ilu.c.o
		  shape.c.o numinteg.c.o assmul.c.o assfull.c.o 
		  asscmd.c.o constinteg.c.o 
		  graphcmd.c.o graphic.c.o postscr.c.o 
		  window.c.o macwindow.c.o 
		  parcmd.c.o params.c.o bpx.c.o tomproblem.c.o stdproblem.c.o

ellkask  kaskade.r
    Rez kaskade.r -append -o ellkask
	SetFile -a B ellkask -c KASK -t APPL
ellkask  {OBJECTS} ellkask.make
	Link -w -c KASK -t APPL 
		{OBJECTS} 
		"{CLibraries}"CLib881.o 
		"{Libraries}"Interface.o 
		"{CLibraries}"CRuntime.o 
		"{CLibraries}"StdCLib.o 
		"{CLibraries}"CSANELib881.o 
		"{CLibraries}"Math881.o 
		"{CLibraries}"CInterface.o 
		"{Libraries}"PerformLib.o 
		-o ellkask -sym on -l > ellkask.linkmap
